<ng-container *transloco="let t">
  <div
    class="table-container app-max-width-wrapper min-clearance-table-width"
    [ngClass]="isPublic ? 'max-table-width' : 'no-max-table-width'">
    <div
      class="info-header count-container"
      [ngClass]="isPublic ? 'flex-horizontal-space' : 'flex-horizontal-end'">
      <div *ngIf="isPublic" class="icon-table-bar">
        <button
          mat-icon-button
          [color]="(isEmailCopied$|async) ? 'accent' : ''"
          [matTooltip]="t((isEmailCopied$|async) ? 'clearances.mail_to_button_copied': 'clearances.mail_to_button')"
          (click)="sendEmailWithLink()">
          <mat-icon>
            {{(isEmailCopied$|async) ? 'check' : 'outgoing_mail'}}
          </mat-icon>
        </button>
        <button
          mat-icon-button
          [color]="(isLinkCopied$|async) ? 'accent' : ''"
          [matTooltip]="t((isLinkCopied$|async) ? 'clearances.link_to_clipboard_copied' : 'clearances.link_to_clipboard')"
          (click)="copyLinkToClipboard()">
          <mat-icon>{{(isLinkCopied$|async) ? 'check' : 'link'}}</mat-icon>
        </button>
        <button
          mat-icon-button
          [color]="(isExcelExported$|async) ? 'accent' : ''"
          [matTooltip]="t((isExcelExported$|async) ? 'clearances.export_to_excel_exec' : 'clearances.export_to_excel')"
          (click)="exportTableToExcel()">
          <mat-icon>
            {{(isExcelExported$|async) ? 'check' : 'file_save'}}
          </mat-icon>
        </button>
      </div>
      <div>{{'clearances.clearances_count'|transloco}}: {{clearanceCount}}</div>
  </div>
    <mat-card appearance="outlined">
      <div>
        <table
          class="table-width vert-ruler"
          mat-table
          matSort
          multiTemplateDataRows
          [dataSource]="dataSource">
          <!-- org name Column -->
          <ng-container matColumnDef="organization_name">
            <th
              mat-header-cell
              *matHeaderCellDef
              mat-sort-header>
              {{t('clearances.organization_th')}}
            </th>
            <td
              mat-cell
              *matCellDef="let row"
              [attr.rowspan]="COMBINED_ROW_COUNT">
              <div
                class="table-header-item"
                [routerLink]="'/'+PUBLIC_ORG_ROUTE+'/'+row?.organization?.organization_id">
                <div class="logo-container">
                  <img [src]="row?.organization?.resized_logo_urls?.w60 ?? FALLBACK_IMAGE" class="org-logo">
                </div>
                <div class="org-name-container">
                  {{row?.organization?.organization_name}}
                </div>
              </div>
            </td>
          </ng-container>
          <!-- Product Name Column -->
          <ng-container matColumnDef="product_name">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              [attr.rowspan]="COMBINED_ROW_COUNT">
              {{row?.product_name}}
            </td>
          </ng-container>
          <!-- Procedure Column -->
          <ng-container matColumnDef="procedure">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.procedures')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.procedures"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="indication">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.indications')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.indications"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="clearance">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('clearances.clearance')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.clearances"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="image_type">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.image_types')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.image_types"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="tissue">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.tissues')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.tissues"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="stain">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.stains')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.stains"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="analysis">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell">
              <div class="tag-item">
                <span class="info-header">{{t('filters.analysis')}}</span>
                <app-translated-tag-list [tags]="row?.tags?.analysis"></app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <ng-container matColumnDef="scanners">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let row"
              class="large-cell"
              colspan="2">
              <div class="tag-item two-columns">
                <span class="info-header">{{t('filters.scanners')}}</span>
                <app-translated-tag-list
                  [tags]="row?.tags?.scanners"
                  [stringFilterList]="SCANNER_VENDOR_NAMES">
                </app-translated-tag-list>
              </div>
            </td>
          </ng-container>
          <!-- actions Column -->
          <ng-container matColumnDef="actions">
            <th
              mat-header-cell
              *matHeaderCellDef
              class="table-column-header-align-end">
              &nbsp;
            </th>
            <td
              mat-cell
              *matCellDef="let element"
              class="action-menu-alignment"
              [attr.rowspan]="COMBINED_ROW_COUNT">
              <button
                *ngIf="!isPublic && element.isHidden"
                mat-icon-button
                [matTooltip]="t('clearances.hide_action')"
                (click)="unhideClearanceClicked.emit(element?.clearanceId); $event.stopPropagation()">
                <mat-icon>visibility_off</mat-icon>
              </button>
              <button
                *ngIf="!isPublic && !element.isHidden"
                mat-icon-button
                [matTooltip]="t('clearances.unhide_action')"
                (click)="hideClearanceClicked.emit(element?.clearanceId); $event.stopPropagation()">
                <mat-icon>visibility</mat-icon>
              </button>
              <button
                *ngIf="!isPublic"
                mat-icon-button
                [matTooltip]="t('clearances.edit_action')"
                (click)="editClearanceItemClicked.emit(element?.clearanceId); $event.stopPropagation()">
                <mat-icon>edit</mat-icon>
              </button>
              <button
                mat-icon-button
                (click)="(expandedElement = expandedElement === element ? null : element); $event.stopPropagation()">
                <mat-icon>{{expandedElement !== element ? 'keyboard_arrow_down' : 'keyboard_arrow_up'}}</mat-icon>
              </button>
            </td>
          </ng-container>
          <!-- Expanded Content Column - The detail row is made up of this one column that spans across all columns -->
          <ng-container matColumnDef="expandedDetail">
            <td
              mat-cell
              *matCellDef="let element; let index = dataIndex;"
              [attr.colspan]="displayedColumns.length">
              <div [@detailExpand]="element === expandedElement ? 'expanded' : 'collapsed'">
                <app-clearances-table-expanded-details [clearanceItem]="element"></app-clearances-table-expanded-details>
              </div>
            </td>
          </ng-container>
          <tbody>
            <ng-container *ngIf="isPublic">
              <tr
                mat-header-row
                *matHeaderRowDef="displayedColumns">
              </tr>
            </ng-container>
            <tr
              mat-row
              *matRowDef="let element; columns: displayedColumns; let index = dataIndex;"
              [ngClass]="{odd_row_color: index % 2 === 0}"
              class="expanded-element-row clickable"
              (click)="expandedElement = expandedElement === element ? null : element">
            </tr>
            <tr
              mat-row
              *matRowDef="let element; columns: secondaryColumns; let index = dataIndex;"
              [ngClass]="{odd_row_color: index % 2 === 0}"
              class="expanded-element-row clickable"
              (click)="expandedElement = expandedElement === element ? null : element">
            </tr>
            <tr
              mat-row
              *matRowDef="let element; columns: tertiaryColumns; let index =dataIndex"
              [ngClass]="{odd_row_color: index % 2 === 0}"
              class="expanded-element-row clickable"
              (click)="expandedElement = expandedElement === element ? null : element">
            </tr>
            <tr
              mat-row
              *matRowDef="let row; columns: ['expandedDetail']; let index = dataIndex;"
              [ngClass]="{odd_row_color: index % 2 === 0}"
              class="expanded-element-detail-row">
            </tr>
            <!-- Row shown when there is no matching data. -->
            <tr
              class="mat-row no-data-table-row"
              *matNoDataRow>
              <td
                class="mat-cell"
                [attr.colspan]="displayedColumns.length">
                {{'general.no_data'|transloco}}
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </mat-card>
  </div>
</ng-container>
